// This #include statement was automatically added by the Particle IDE.
#include <Adafruit_SSD1306_RK.h>

#include "application.h"
SYSTEM_MODE (AUTOMATIC);
SYSTEM_THREAD (ENABLED);
#include "MAX30100_PulseOximeter.h"
#include "application.h"
#define REPORTING_PERIOD_MS     1000
#define slaveAddress 0x5A


PulseOximeter pox;
int BPM,sp;
float t;
uint32_t tsLastReport = 0;
uint32_t tsLastReport1 = 0;
int LED = D7;
// Callback (registered below) fired when a pulse is detected


//////////////////////////////////////////////////////////

const BleUuid serviceUuid("5c1b9a0d-b5be-4a40-8f7a-66b36d0a5176");
BleCharacteristic spo2Characteristic("spo2", BleCharacteristicProperty::NOTIFY, BleUuid("fdcf4a3f-3fed-4ed2-84e6-04bbb9ae04d4"), serviceUuid);
BleCharacteristic bpmSourceCharacteristic("bpm", BleCharacteristicProperty::NOTIFY, BleUuid("cc97c20c-5822-4800-ade5-1f661d2133ee"), serviceUuid);
BleCharacteristic beatCharacteristic("beat", BleCharacteristicProperty::NOTIFY, BleUuid("d2b26bf3-9792-42fc-9e8a-41f6107df04c"), serviceUuid);

///////////////////////////////////////////////////////////////////////////////////////////////////////////////

void onBeatDetected()
{
    Serial.println("Beat!");
  digitalWrite(LED,1);
}

void setup()
{
    pinMode(LED,OUTPUT);
    Serial.begin(115200);
    pox.begin();
    pox.setOnBeatDetectedCallback(onBeatDetected);
    
     /// ble char setting 
	BLE.addCharacteristic(spo2Characteristic);
	BLE.addCharacteristic(bpmSourceCharacteristic);
	BLE.addCharacteristic(beatCharacteristic);
    ///for blr 
	BleAdvertisingData advData;
	// Advertise our private service only
	advData.appendServiceUUID(serviceUuid);
    // Continuously advertise when not connected
	BLE.advertise(&advData);
}

void loop()
{
    
pox.update();
BPM=pox.getHeartRate();
sp=pox.getSpO2();
digitalWrite(LED,1);
Serial.print("Heart rate:");
Serial.print(BPM);
Serial.print("bpm / SpO2:");
Serial.print(sp);
Serial.println("% ");
  digitalWrite(LED,0);
  
  			uint8_t sp02level[1];
			uint8_t bpmlevel[1];
			
			sp02level[0] = sp>> 4;
			bpmlevel[0] = BPM >> 4;
		
			
		    spo2Characteristic.setValue(sp02level);
		    bpmSourceCharacteristic.setValue(bpmlevel);
		   
		    
   
    
    Mesh.publish("spo2", String(sp));
    Mesh.publish("bpm", String(BPM));
  
if (millis() - tsLastReport1 > 1000) {
Particle.publish("BPM", String(BPM));
Particle.publish("spo2", String(sp));
Particle.publish("temp", String(t));
tsLastReport1 = millis();
}

}
